--#
--# Copyright (C)2002..2019 @BABOLO http://www.babolo.ru/
--# PKG = babolo_pglib
--# All rights reserved.
--#
--# Redistribution and use in source and binary forms, with or without
--# modification, are permitted provided that the following conditions
--# are met:
--# 1. Redistributions of source code must retain the above copyright
--#    notice, this list of conditions and the following disclaimer.
--# 2. Redistributions in binary form must reproduce the above copyright
--#    notice, this list of conditions and the following disclaimer in the
--#    documentation and/or other materials provided with the distribution.
--#
--# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
--# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
--# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
--# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
--# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
--# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
--# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
--# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
--# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
--# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
--# SUCH DAMAGE.
--#
--# $Id: babolo_pglib--1.04.sql.m4,v 1.7 2019/04/19 00:43:06 babolo Exp $

--########################################################################
--#  pglib_bytea
--########################################################################

CREATE OR REPLACE FUNCTION bytea(int4, int4) RETURNS bytea
 AS 'MODULE_PATHNAME/pglib_bytea.so.VMAJOR', 'int4_bytea'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION bytea(int4, int4)
 IS '      ,   '
;

CREATE OR REPLACE FUNCTION bytea(int4) RETURNS bytea
 AS 'SELECT bytea($1, 4)'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION bytea(int4)       IS '    bytea';

CREATE OR REPLACE FUNCTION bytea(int8, int4) RETURNS bytea
 AS 'MODULE_PATHNAME/pglib_bytea.so.VMAJOR', 'int8_bytea'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION bytea(int8, int4)
 IS '      ,   '
;

CREATE OR REPLACE FUNCTION bytea(int8) RETURNS bytea
 AS 'SELECT bytea($1, 8)'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION bytea(int8)       IS '    bytea';

CREATE OR REPLACE FUNCTION bytea(text) RETURNS bytea
 AS 'MODULE_PATHNAME/pglib_bytea.so.VMAJOR', 'text_bytea'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION bytea(text)       IS '    bytea';

CREATE OR REPLACE FUNCTION text(bytea) RETURNS text
 AS 'MODULE_PATHNAME/pglib_bytea.so.VMAJOR', 'bytea_text'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION text(bytea)       IS '    text';

CREATE OR REPLACE FUNCTION bytearradd(bytea, bytea) RETURNS bytea
 AS 'MODULE_PATHNAME/pglib_bytea.so.VMAJOR', 'bytearradd'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION bytearradd(bytea, bytea)
 IS '      255'
;

CREATE AGGREGATE bytearrsum
     (bytea)
     ( SFUNC = bytearradd
     , STYPE = bytea
     , SSPACE = 12
     , INITCOND = ''
     , COMBINEFUNC = bytearradd
     , PARALLEL = SAFE
     )
;
COMMENT ON AGGREGATE bytearrsum(bytea) IS '    255';
